<?
// Generates the dynamic meta tags for any page, depending on its querystring.
require_once('functions.phps');

$title='The UniSearcher';
$desc='The UniSearcher. An interactive, fun-to-use Unicode database front-end, ' .
    'designed specifically to make the life of web designers and programmers alike easier ' .
    '(because I\'m both) by making it effortless to find Unicode/UTF-8 characters in various encoding ' .
    'methods, enabling reproducing them hither and yon with clarity and grace. So the dream goes.';
$keys='unicode, interactive, unicode chart, unicode charts, unicode search, unicode searcher, unicode character, unicode characters, unicode database, unicode lookup, unicode look up, codepoint, code point, glyph, unicode utf8, unicode utf-8, unicode utf 8';

$misc='<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<meta name="author" content="Brett Baugh - phee at isthisthingon dot org" />
<meta name="classification" content="Unicode Utility" />
<meta name="distribution" content="Global" />
<meta name="doc-class" content="Completed" />
<meta name="doc-type" content="Web Page" />
<meta name="generator" content="pico v4.10" />
<meta name="MSSmartTagsPreventParsing" content="TRUE" />
<meta name="reply-to" content="phee@isthisthingon.org (Brett Baugh)" />';

if (isset($G['glyph'])) {
    $inf=GlyphInfo($G['glyph']);
    $title.=': Details for ' . Codepoint2Utf8($inf['deccode']) . " (0x{$inf['hexcode']}, {$inf['deccode']})";
    $keys.=', 0x' . $inf['hexcode'];
} elseif (IsSearchPage()) {
    $title.=": Search Results";
} else {
    if (isset($G['charblock']) || (isset($G['subpage']) && isset($G['page']))) {
        $title.=": Character Block " . hexpad($G['page'].$G['subpage'].'00') . ' - ' .
            hexpad($G['page'].$G['subpage'].'FF');
    } elseif (isset($G['page'])) {
        $title.=": Mid-Navigation: Page " . hexpad($page, 2) . 'xxx';
    }
}
define('TITLE', $title);

$Fdesc = '<meta name="description" content="' . qs($desc) . '" />';
$Fkeys = '<meta name="keywords" content="' . qs($keys) . '" />';
$Ftitle='<meta name="title" content="' . qs($title) . '" />';
echo "$misc\n$Ftitle\n$Fdesc\n$Fkeys\n";
